// BOLT SYSTEM, 48 MHZ, 18F2550, C18 COMPILER V3.40, MPLAB V8.63
// Demonstration program with 4 functions. CONNECT
// LCD 16X1 AND KEYBOARD MODULE TO BOLT 18F2550.
// RESET TO START EACH APPLICATION.
// Put all the microswitches INITIALLY IN "OFF"
// And reset the module to see instructions on the LCD.
// SW1 = ON, MESSAGE IMPLEMENTATION OF 400 CHARACTERS IN LCD.
// SW2 = ON, TEMPERATURE SENSOR. SHOWS IN LCD DEGREES CENTIGRADES.
// SW3 = ON, APPLICATION electronic lock. Enter password= 3408
// in hexadecimal keyboard (ENTER "F" at the end)
// If the password is correct, ACTIVE relay for 2 seconds.
// SW4 = ON, REAL TIME CLOCK APPLICATION-Enter the hour-minute-
// Seconds,EXAMPLE: 094512  (ENTER "F" at the end).
#include <p18cxxx.h>
#include <delays.h>
#include <timers.h>
#include "18F2550BOLT.h"
#include "ONEWIRE.h"
#include <stdio.h>	//librera sprintf()
#include <stdlib.h>	//libreras atoi(),atof()

/*FUNCIONES DISPONIBLES*/
#define CLOCK_TIMER0 12000000;	//es la frecuencia (hertz) con la que se modifica el registro de 16 bits del TIMER0
void timer_isr(void);
void LCD_CEROS(void);
void DISPLAY_LCD(void);
void SET_TIME(void);
void f1(void);			/*MUESTRA EN EL LCD LAS CARACTERISTICAS DEL MODULO BOLT 18F2550, CON CORRIMIENTO DINAMICO*/
void f2(void);			/*APLICACION SENSOR DE TEMPERATURA*/
void f3(void);			/*APLICACION CHAPA ELECTRONICA, OPRIMIR CLAVE DESDE EL TECLADO HEXADECIMAL*/
void f4(void);		
void f5(void);			/*MUESTRA LAS INSTRUCCIONES PARA EL USO DEL PROGRAMA DEMOSTRATIVO EN EL LCD*/

/*VECTORES DE RESET Y DE INTERRUPCIN*/
extern void _startup( void ); 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code _HIGH_INTERRUPT_VECTOR = 0x000808
void _high_ISR (void)
{
	_asm goto timer_isr _endasm
}

/*DEFINICION DE VARIABLES GLOBALES:*/
#pragma code
int long Ticker; 
int Segundos=0; 
int segundo_previo=0;
int Year=0,Mes=0,Dia=0,Hora=0,Minuto=0; 
#define BISIESTO(Year) (Year%4 == 0);
long int yuan;
char clave[]="PASS:";
char ok[]="OK!!";
char nok[]="no";
const rom char wav[600]="................BOLT 18F2550 SYSTEM..48 MHZ..USB PORT WITH BOOTLOADER PROGRAMMER..32K FLASH MEMORY..2K RAM MEMORY..256 BYTES EEPROM..TEMPERATURE SENSOR DS18B20..RELAY 127 VAC, 1 AMP..PLUG FOR EXTERNAL WALL TRANSFORMER..8 LEDS..4 MICROSWITCHES..SERIAL PORT RS-232..LCD AND KEYPAD PORTS..PROFESSIONAL DEVELOPMENT SOFTWARE, INCLUDES MPLAB IDE..C18 COMPILER..PROGRAMMING SOFTWARE BOLT V.1.0.1...............";
const rom char wov[600]="................PUNTO FLOTANTE S.A..BOLT 18F2550 SYSTEM..DEMO WITH 4 APPS: SW1=ON >> SHOWS IN LCD FEATURES OF BOLT 18F2550 MODULE..SW2=ON >> DIGITAL TEMPERATURE SENSOR DS18B20..SW3=ON >> ELECTRONIC LOCK, PASSWORD=3408 FROM KEYPAD (TYPE 'F' AT THE END)..SW4=ON >> REAL TIME CLOCK: TYPE HOUR-MINUTES-SECONDS WITH 6 CONSECUTIVE DIGITS AND 'F' AT THE END..PUSH RESET BUTTON TO START EACH APPLICATION................";
char web[20];
int a=0,b=0;
float GRADOS;
int entero,decimal;					//float GRADOS;
char array[5];
char TEMPE[]="TEMPE=";

#pragma interrupt timer_isr
void timer_isr(void)
{
Ticker=Ticker-65536;                    // Decrementa ticker  
  if (Ticker<65536)                      // si ya transcurri un segundo 
  {
	Ticker=Ticker+CLOCK_TIMER0;      	//   Incrementa ticker 
    Segundos++;                           //   Incrementa numero de segundos 
  } 
				if(Segundos == 60) 
				{
				Minuto++; Segundos=0; 
    				if(Minuto == 60) 
					{
					Hora++; Minuto=0; 
      					if(Hora == 24) 
						{
						Dia++; Hora=0; 
  						} 
					}		
				}  
INTCONbits.TMR0IF = 0 ;				//habilita de nuevo interrupcin
}

void main(void) 
{
init_bolt();
if(SW1==0)f1();
if(SW2==0)f2();
if(SW3==0)f3();
if(SW4==0)f4();
f5();
for(;;);	
}

void f1(void)
{
init_bolt();
InitLCD();
ClearScreen();
malla:
	b=b+1;
		for(a=0;a<16;a++)		//CARGA MENSAJE DE BUFFER PRINCIPAL
		{web[a]=wav[a+b];}

	GotoXY(0,0);			//ESCRIBE EN RENGLON 0, 8 CARACTERES
		for(a=0;a<8;a++)
		{PutLCD(web[a]);}

	GotoXY(1,0);			//ESCRIBE EN RENGLON 1, 8 CARACTERES
		for(a=8;a<16;a++)
		{PutLCD(web[a]);}

	delay_ms(275);
	if(wav[b+16]==0)b=0;
goto malla;
}

void f2(void)
{
init_bolt();
InitLCD();
ClearScreen();
PrintString(TEMPE);
	while(1)
	{
	GRADOS=ds1820_read();				//GRADOS ES VARIABLE DE PUNTO FLOTANTE
	entero=GRADOS;					//PARTE ENTERA
	decimal=(GRADOS-entero)*10;			//PARTE DECIMAL
	sprintf(array,"%3d.%d",entero,decimal);		//CONVIERTE A STRING 
	GotoXY(1,0);
	PrintString(array);
	PutLCD(32);
	PutLCD(214);
	PutLCD('C');
	delay_ms(800);
	}
}

void f3(void)
{
init_bolt();
InitLCD();
loop:
ClearScreen();
GotoXY(0,0);
PrintString(clave);
PutLCD('>');
GotoXY(1,0);
SetBot();
yuan=atoi(bot);
	if(yuan==3408)
	{
	ClearScreen();
	PrintString(ok);
	RELE=1; delay_ms(2000); RELE=0;
	}
	else 
	{
	ClearScreen();
	PrintString(nok);
	delay_ms(1000);
	}
goto loop;
}

void f5(void)
{
init_bolt();
InitLCD();
ClearScreen();
malla:
	b=b+1;
		for(a=0;a<16;a++)		//CARGA MENSAJE DE BUFFER PRINCIPAL
		{web[a]=wov[a+b];}

	GotoXY(0,0);			//ESCRIBE EN RENGLON 0, 8 CARACTERES
		for(a=0;a<8;a++)
		{PutLCD(web[a]);}

	GotoXY(1,0);			//ESCRIBE EN RENGLON 1, 8 CARACTERES
		for(a=8;a<16;a++)
		{PutLCD(web[a]);}

	delay_ms(275);
	if(wov[b+16]==0)b=0;
goto malla;
}


void f4() 
{
	init_bolt();
	PORTB=0;
	SET_TIME();
	Ticker=CLOCK_TIMER0;
	OpenTimer0 (TIMER_INT_ON & T0_SOURCE_INT & T0_16BIT);			//INICIALIZA PARAMETROS DEL TIMER 0
	INTCONbits.GIE = 1; 											//enable global interrupts
	LCD_CEROS();
  		while(1) 
  			{ 
			if (Segundos != segundo_previo) 
    			{
				segundo_previo=Segundos; 
      			DISPLAY_LCD();
    			}  
  			} 
} 

void LCD_CEROS(void)
{
 char HORA[]="HORA:";
 char CEROS[10]="00:00:00";		//HORA INICIAL
 InitLCD();
 ClearScreen();
 PrintString(HORA);
 GotoXY(1,0);
 PrintString(CEROS);
} 

void DISPLAY_LCD(void)
{
 char wob[10];
 GotoXY(1,0);
 sprintf(wob,"%02u",Hora);
 PrintString(wob); 
 GotoXY(1,3);
 sprintf(wob,"%02u",Minuto);
 PrintString(wob); 
 GotoXY(1,6);
 sprintf(wob,"%02u",Segundos);
 PrintString(wob); 
}

void SET_TIME(void)
{
char buf[3];
char SET[]="SET>";
InitLCD();
ClearScreen();
PrintString(SET);
GotoXY(1,0);
SetBot();				//INGRESA LA HORA (6 DIGITOS CONSECUTIVOS) Y "F" AL FINAL
GotoXY(1,0);
WrtBot();
buf[0]=bot[0];
buf[1]=bot[1];
buf[2]=0;
Hora=atoi(buf);
buf[0]=bot[2];
buf[1]=bot[3];
buf[2]=0;
Minuto=atoi(buf);
buf[0]=bot[4];
buf[1]=bot[5];
buf[2]=0;
Segundos=atoi(buf);
}

